import { DemensionPagesListInter, DemensionPagesInter } from './../js-pages/types'
import { useRoute } from 'vue-router'
import router from '@/router'
import pagesArr from '@/js-pages'
import dayjs from 'dayjs'
import { config } from '../../config'
import h5JumpApp from './app'
import emptyImg from '@/assets/img/custom-empty-image.png'


const h5jumpApp = new h5JumpApp();
export const $_sendAppFunction = (name: string | number, params: any) => { //跳企业Native
  // eslint-disable-next-line no-undef
  if (h5jumpApp.systemJudge() == 'Android') {
    // @ts-ignore
    winhc[name](params)
  } else {
    // eslint-disable-next-line no-undef
    h5jumpApp.ocMethod(name, {
      [params]: params
    })
  }
}

export const $downApp = () => { //跳企业Native
  window.location.href = config.downloadAppUrl
  return
}

export const $copyText = (text:string, back:Function) => {
  $_sendAppFunction('copyText', text)
  // if ($pageType == 'H5') {
  //   return
  // }
  back && back()
}



//全局注册方法
export const $emptyImg = emptyImg

export const $nameByCompanyName = function (company: string | string[], type: string) {
  let name = type
  if (company && company.indexOf('有限合伙') != -1) {
    if (type == '法定代表人') {
      name = '执行事务合伙人'
    } else if (type == '股东信息') {
      name = '合伙人信息'
    } else if (type == '持股比例') {
      name = '出资比例'
    }
  }
  return name
}


//打开图片
export const $openImg = (img: string) => {
  console.log(img)
}
//时间格式化
export const $dateFormat = (date: string) => {
  return dayjs(date).format('YYYY-MM-DD')
}
//跳转企业
export const $goCompany = (companyName: string, companyId: string) => {
  console.log(companyName, companyId)
  

    try {
        if (h5jumpApp.systemJudge() == 'Android') {
          // @ts-ignore
          winhc.goCompany(companyName)
        } else {
          h5jumpApp.ocMethod('goCompany', {
                company:companyName,
            })
        }
    } catch (error) {
        
    }

}

export const $goPersonal = function (personName:string, companyName:string) {//跳个人Native

  
  if(personName && !['-','--'].includes(personName)){
      if (h5jumpApp.systemJudge() == 'Android') {
        // @ts-ignore
          winhc.personalPage(personName, companyName,'')
      } else {
        h5jumpApp.ocMethod('personalPage', {
              "personName": personName,
              "companyName": companyName,
              "humanId": "",
          })
      }
  }

};

//跳APP内部页面
export const $goInnerPage = (page: string, comopanyName = '', monitorId = '0') => {
  console.log(page, comopanyName, monitorId)
}

//是否是企业
export const $isCompanyClass = (companyId: string) => {
  if (companyId) {
    return 'link'
  }
  return ''
}

//选择匹配的企业维度
export const $getDemension = (routerName?: string) => {
  console.log(routerName)

  const route = useRoute()
  console.log(route.params.routerName)

  const allDemensionArr = [] as DemensionPagesListInter[]
  const demensionArr = (arr: any[]): DemensionPagesInter[] => {
    return arr.reduce((total, item: any) => item.list ? demensionArr(item.list) : allDemensionArr.push(item), [])
  }
  demensionArr(pagesArr)
  const selectDemension = allDemensionArr.find(item => (routerName ? `${routerName}` : route.params.routerName) === `${item.routing}`)!

  return {
    selectDemension,
    allDemensionArr
  }
}

export const $goDetail = (url:string,type?:string)=>{//跳详情
  let tempUrl = url + (url.indexOf('?') == -1 ? '?' : '&') + 'sessionId=' + localStorage.getItem('qccSessionId')
  if(type == 'ws'){
      tempUrl += '&immersion=all'
  }
  
  //开发环境直接跳转
  if(import.meta.env.MODE === 'development'){
    router.push('/'+url)
    return
  }

  // console.log('tempUrl=', tempUrl)
  if (h5jumpApp.systemJudge() == 'Android') {
      if(type == 'ws'){
        // @ts-ignore
          winhc.openLegalServiceWebPage(config.commonUrl + tempUrl,"Y")
      }else{
        // @ts-ignore
          winhc.qccDetail(tempUrl)
      }
  } else {
      if(type == 'ws'){//文书详情是自定义头部
          const obj = {
              pageUrl: config.commonUrl + tempUrl, // 页面打开连接
              immersion:'all'  //是否是沉浸式标题， Y  是沉浸式
          }
          h5jumpApp.ocMethod('openPageWithShareBtn', obj)
      }else{
        h5jumpApp.ocMethod('qccDetail', {
              "url": tempUrl,
          })
      }
     
  }
}

//定义返回按钮事件
export const $historyGoBack = ()=>{
  if (h5jumpApp.systemJudge() == 'Android') {
    // @ts-ignore
      winhc.historyGoBack()
  } else {
    h5jumpApp.ocMethod('goBack', {})
  }
}

export const $goInAppPage = (type?:string)=>{
  if (h5jumpApp.systemJudge() == 'Android') {
     // @ts-ignore
      winhc.goInAppPage(type)
  } else {
    h5jumpApp.ocMethod('goInAppPage', {
          'type':type
      })
  }
}

export const $openBuyVipPopup = (type=0)=>{
  // 股权结构图谱(1, "股权结构图谱"),
  // 债权图谱(2, "债权图谱"),
  // 最终受益人(3, "最终受益人"),
  // 控股企业(4, "控股企业"),
  // 财产线索(5, "财产线索"),
  // 司法案件详情(10, "司法案件详情"),
  // 司法案件(6, "司法案件"),
  // 合同模板(7, "合同模板"),
  // 监测动态(8, "监测动态"),
  // 动态详情(9, "动态详情"),
  // 财产线索提醒(11, "财产线索提醒"),
  // 风险信息_公司(12, "风险信息公司"),
  // 风险信息_人(13, "风险信息个人"),
  // 智能法顾(14, "智能法顾"),
  // 履债评估(15, "履债评估");
  // 司法案件监测(10,'司法案件监测')
  try {
      if (h5jumpApp.systemJudge() == 'Android') {
        // @ts-ignore
          winhc.openBuyVipPopupByParam('recharge',type)
      } else {
        h5jumpApp.ocMethod('openBuyVipPopupByParam', {
              type:'recharge',
              funcStyle:type
          })
      }
  } catch (e) {
      console.log(e)
  }
}



//跳转外部URL
export const $goOuterUrl = (url: string) => {
  window.open(url)
}

export const methods ={
  isemail:function (mail:string):boolean{
      var reg = /^([A-Za-z0-9_\-\.])+\@([A-Za-z0-9_\-\.])+\.([A-Za-z]{2,4})$/;
      return reg.test(mail);
  },
  is_weixin:function():boolean{
      const ua = navigator.userAgent.toLowerCase();
      return /micromessenger/i.test(ua);
  },
 isWeiBo:function():boolean{
    const ua = navigator.userAgent.toLowerCase();
    return /WeiBo/i.test(ua);
  },
  isQQ:function():boolean{
    const ua = navigator.userAgent.toLowerCase();
    return /QQ/i.test(ua);
  }
}
